"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var env_1 = require("./env");
var appIconBadgeConfig = {
    enabled: env_1.Env.APP_ENV !== 'production',
    badges: [
        {
            text: env_1.Env.APP_ENV,
            type: 'banner',
            color: 'white',
        },
        {
            text: env_1.Env.VERSION.toString(),
            type: 'ribbon',
            color: 'white',
        },
    ],
};
exports.default = (function (_a) {
    var config = _a.config;
    return (__assign(__assign({}, config), { name: env_1.Env.NAME, description: "".concat(env_1.Env.NAME, " Mobile App"), owner: env_1.Env.EXPO_ACCOUNT_OWNER, scheme: env_1.Env.SCHEME, slug: 'obytesapp', version: env_1.Env.VERSION.toString(), orientation: 'portrait', icon: './assets/icon.png', userInterfaceStyle: 'automatic', newArchEnabled: true, updates: {
            fallbackToCacheTimeout: 0,
        }, assetBundlePatterns: ['**/*'], ios: {
            supportsTablet: true,
            bundleIdentifier: env_1.Env.BUNDLE_ID,
        }, experiments: {
            typedRoutes: true,
        }, android: {
            adaptiveIcon: {
                foregroundImage: './assets/adaptive-icon.png',
                backgroundColor: '#2E3C4B',
            },
            package: env_1.Env.PACKAGE,
        }, web: {
            favicon: './assets/favicon.png',
            bundler: 'metro',
        }, plugins: [
            [
                'expo-splash-screen',
                {
                    backgroundColor: '#2E3C4B',
                    image: './assets/splash-icon.png',
                    imageWidth: 150,
                },
            ],
            [
                'expo-font',
                {
                    fonts: ['./assets/fonts/Inter.ttf'],
                },
            ],
            'expo-localization',
            'expo-router',
            ['app-icon-badge', appIconBadgeConfig],
        ], extra: __assign(__assign({}, env_1.ClientEnv), { eas: {
                projectId: env_1.Env.EAS_PROJECT_ID,
            } }) }));
});
//# sourceMappingURL=app.config.js.map