"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var test_utils_1 = require("@/lib/test-utils");
var login_form_1 = require("./login-form");
afterEach(test_utils_1.cleanup);
var onSubmitMock = jest.fn();
describe('LoginForm Form ', function () {
    it('renders correctly', function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    (0, test_utils_1.setup)(<login_form_1.LoginForm />);
                    _a = expect;
                    return [4 /*yield*/, test_utils_1.screen.findByText(/Sign in/i)];
                case 1:
                    _a.apply(void 0, [_b.sent()]).toBeOnTheScreen();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should display required error when values are empty', function () { return __awaiter(void 0, void 0, void 0, function () {
        var user, button, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    user = (0, test_utils_1.setup)(<login_form_1.LoginForm />).user;
                    button = test_utils_1.screen.getByTestId('login-button');
                    expect(test_utils_1.screen.queryByText(/Email is required/i)).not.toBeOnTheScreen();
                    return [4 /*yield*/, user.press(button)];
                case 1:
                    _b.sent();
                    _a = expect;
                    return [4 /*yield*/, test_utils_1.screen.findByText(/Email is required/i)];
                case 2:
                    _a.apply(void 0, [_b.sent()]).toBeOnTheScreen();
                    expect(test_utils_1.screen.getByText(/Password is required/i)).toBeOnTheScreen();
                    return [2 /*return*/];
            }
        });
    }); });
    it('should display matching error when email is invalid', function () { return __awaiter(void 0, void 0, void 0, function () {
        var user, button, emailInput, passwordInput, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    user = (0, test_utils_1.setup)(<login_form_1.LoginForm />).user;
                    button = test_utils_1.screen.getByTestId('login-button');
                    emailInput = test_utils_1.screen.getByTestId('email-input');
                    passwordInput = test_utils_1.screen.getByTestId('password-input');
                    return [4 /*yield*/, user.type(emailInput, 'yyyyy')];
                case 1:
                    _b.sent();
                    return [4 /*yield*/, user.type(passwordInput, 'test')];
                case 2:
                    _b.sent();
                    return [4 /*yield*/, user.press(button)];
                case 3:
                    _b.sent();
                    _a = expect;
                    return [4 /*yield*/, test_utils_1.screen.findByText(/Invalid Email Format/i)];
                case 4:
                    _a.apply(void 0, [_b.sent()]).toBeOnTheScreen();
                    expect(test_utils_1.screen.queryByText(/Email is required/i)).not.toBeOnTheScreen();
                    return [2 /*return*/];
            }
        });
    }); });
    it('Should call LoginForm with correct values when values are valid', function () { return __awaiter(void 0, void 0, void 0, function () {
        var user, button, emailInput, passwordInput;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    user = (0, test_utils_1.setup)(<login_form_1.LoginForm onSubmit={onSubmitMock}/>).user;
                    button = test_utils_1.screen.getByTestId('login-button');
                    emailInput = test_utils_1.screen.getByTestId('email-input');
                    passwordInput = test_utils_1.screen.getByTestId('password-input');
                    return [4 /*yield*/, user.type(emailInput, 'youssef@gmail.com')];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, user.type(passwordInput, 'password')];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, user.press(button)];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, (0, test_utils_1.waitFor)(function () {
                            expect(onSubmitMock).toHaveBeenCalledTimes(1);
                        })];
                case 4:
                    _a.sent();
                    // expect.objectContaining({}) because we don't want to test the target event we are receiving from the onSubmit function
                    expect(onSubmitMock).toHaveBeenCalledWith({
                        email: 'youssef@gmail.com',
                        password: 'password',
                    }, expect.objectContaining({}));
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=login-form.test.js.map